/*++

Copyright (c) 1990-2000 Microsoft Corporation All Rights Reserved

Module Name:

    Toaster.h

Abstract:

    Header file for the toaster driver modules.

Environment:

    Kernel mode

--*/


#if !defined(_TOASTER_H_)
#define _TOASTER_H_

#include <ntddk.h>
#include <wdf.h>


#define NTSTRSAFE_LIB
#include <ntstrsafe.h>

#include "wmilib.h"
#include <initguid.h>
#include "driver.h"
#include "public.h"

#define TOASTER_POOL_TAG (ULONG) 'saoT'

#define MOFRESOURCENAME L"ToasterWMI"


#define NT_DEVICE_NAME                  L"\\Device\\Toaster"
#define DOS_DEVICE_NAME                 L"\\DosDevices\\Toaster"

//
// The device extension for the device object
//
typedef struct _DRIVER_DEVICE_CONTEXT
{
	UCHAR               PortASave;
    UCHAR               PortBSave; 
    BOOLEAN     WmiPowerDeviceEnableRegistered;

}  DRIVER_DEVICE_CONTEXT, *PDRIVER_DEVICE_CONTEXT;

WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(DRIVER_DEVICE_CONTEXT, GetDeviceContext)

#define TOASTER_WMI_STD_I8042 0
#define TOASTER_WMI_STD_SERIAL 1
#define TOASTER_WMI_STD_PARALEL 2
#define TOASTER_WMI_STD_USB 3
	
#define FILE_DEVICE_FILE_SYSTEM 0x00000009	

	
#define FILE_DEVICE_WDFDIO 0xCF54
	
#define IOCTL_WDFDIO_OUTPUT CTL_CODE(FILE_DEVICE_WDFDIO, 2049, METHOD_BUFFERED, FILE_ANY_ACCESS)	
	
	
	
//#define FSCTL_GET_VOLUME_BITMAP \
//    CTL_CODE( FILE_DEVICE_FILE_SYSTEM, 27, METHOD_NEITHER, FILE_ANY_ACCESS )	

DRIVER_INITIALIZE DriverEntry;

EVT_WDF_DRIVER_DEVICE_ADD DriverEvtDeviceAdd;

//
// Io events callbacks.
//

EVT_WDF_IO_QUEUE_IO_DEVICE_CONTROL DriverEvtIoDeviceControl;

//
// WMI event callbacks
//

#endif  // _TOASTER_H_